## quickfix 1.13.3+dfsg

=== UnitTest++/Makefile ===
CXX = g++
CXXFLAGS ?= -g -Wall -W -Winline -ansi 
LDFLAGS ?= 
SED = sed
MV = mv
RM = rm

.SUFFIXES: .o .cpp

lib = libUnitTest++.a
test = TestUnitTest++

src = src/AssertException.cpp \
	src/Test.cpp \
	src/Checks.cpp \
	src/TestRunner.cpp \
	src/TestResults.cpp \
	src/TestReporter.cpp \
	src/TestReporterStdout.cpp \
	src/ReportAssert.cpp \
	src/TestList.cpp \
	src/TimeConstraint.cpp \
	src/TestDetails.cpp \
	src/MemoryOutStream.cpp \
	src/DeferredTestReporter.cpp \
	src/DeferredTestResult.cpp \
	src/XmlTestReporter.cpp \
	src/CurrentTest.cpp
	
ifeq ($(MSYSTEM), MINGW32)
  src += src/Win32/TimeHelpers.cpp
else
  src += src/Posix/SignalTranslator.cpp \
	src/Posix/TimeHelpers.cpp
endif

test_src = src/tests/Main.cpp \
	src/tests/TestAssertHandler.cpp \
	src/tests/TestChecks.cpp \
	src/tests/TestUnitTest++.cpp \
	src/tests/TestTest.cpp \
	src/tests/TestTestResults.cpp \
	src/tests/TestTestRunner.cpp \
	src/tests/TestCheckMacros.cpp \
	src/tests/TestTestList.cpp \
	src/tests/TestTestMacros.cpp \
	src/tests/TestTimeConstraint.cpp \
	src/tests/TestTimeConstraintMacro.cpp \
	src/tests/TestMemoryOutStream.cpp \
	src/tests/TestDeferredTestReporter.cpp \
	src/tests/TestXmlTestReporter.cpp \
	src/tests/TestCurrentTest.cpp

objects = $(patsubst %.cpp, %.o, $(src))
test_objects = $(patsubst %.cpp, %.o, $(test_src))
dependencies = $(subst .o,.d,$(objects))
test_dependencies = $(subst .o,.d,$(test_objects))

define make-depend
  $(CXX) $(CXXFLAGS) -M $1 | \
  $(SED) -e 's,\($(notdir $2)\) *:,$(dir $2)\1: ,' > $3.tmp
  $(SED) -e 's/#.*//' \
      -e 's/^[^:]*: *//' \
      -e 's/ *\\$$//' \
      -e '/^$$/ d' \
      -e 's/$$/ :/' $3.tmp >> $3.tmp
  $(MV) $3.tmp $3
endef


all: $(test)


$(lib): $(objects) 
	@echo Creating $(lib) library...
	@ar crs $(lib) $(objects)
    
$(test): $(lib) $(test_objects)
	@echo Linking $(test)...
	@$(CXX) $(LDFLAGS) -o $(test) $(test_objects) $(lib)
	@echo Running unit tests...
	@./$(test)

clean:
	-@$(RM) $(objects) $(test_objects) $(dependencies) $(test_dependencies) $(test) $(lib) 2> /dev/null

%.o : %.cpp
	@echo $<
	@$(call make-depend,$<,$@,$(subst .o,.d,$@))
	@$(CXX) $(CXXFLAGS) -c $< -o $(patsubst %.cpp, %.o, $<)

install:

uninstall:

check:

ifneq "$(MAKECMDGOALS)" "clean"
-include $(dependencies)
-include $(test_dependencies)
endif

## quickfix 1.13.3%2Bdfsg

=== debian/control ===
Source: quickfix
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Athena Capital Research <acr-debian@athenacr.com>
Uploaders: Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: debhelper (>= 5), autotools-dev, automake1.11, quilt, libxml2-dev, libmysqlclient-dev, libpqxx3-dev, libboost-all-dev, autoconf, automake, libtool
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.quickfixengine.org/index.html
Vcs-Browser: https://github.com/quickfix/quickfix
Vcs-Git: git://github.com/quickfix/quickfix.git

Package: libquickfix-dev
Section: libdevel
Architecture: any
Depends: libquickfix14v5 (= ${binary:Version}), ${misc:Depends}
Suggests: libquickfix-doc
Description: FIX protocol library - development files
 The Financial Information eXchange (FIX) Protocol is a message standard
 developed to facilitate the electronic exchange of information related to
 securities transactions. It is intended for use between trading partners
 wishing to automate communications.
 .
 This package includes the quickfix development files.

Package: libquickfix14v5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libquickfix14
Replaces: libquickfix14
Description: FIX protocol library - runtime files
 The Financial Information eXchange (FIX) Protocol is a message standard
 developed to facilitate the electronic exchange of information related to
 securities transactions. It is intended for use between trading partners
 wishing to automate communications.
 .
 This package includes the quickfix runtime files.

Package: libquickfix14v5-dbg
Section: debug
Architecture: any
Depends: libquickfix14v5 (= ${binary:Version}), ${misc:Depends}
Conflicts: libquickfix14-dbg
Replaces: libquickfix14-dbg
Description: FIX protocol library - debugging symbols
 The Financial Information eXchange (FIX) Protocol is a message standard
 developed to facilitate the electronic exchange of information related to
 securities transactions. It is intended for use between trading partners
 wishing to automate communications.
 .
 This package includes the quickfix debugging symbols.

Package: libquickfix-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libquickfix-dev
Description: FIX protocol library - documentation
 The Financial Information Exchange (FIX) Protocol is a message standard
 developed to facilitate the electronic exchange of information related to
 securities transactions. It is intended for use between trading partners
 wishing to automate communications.
 .
 This package includes the quickfix documentation.

## quickfix 1.13.3+dfsg

=== debian/changelog ===
quickfix (1.13.3+dfsg-8ubuntu1) trusty; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Use autotools-dev dh helper instead of manually copying
      config.{sub,guess} to fix FTBFS on arm64.

 -- Logan Rosen <logan@ubuntu.com>  Wed, 09 Apr 2014 13:24:18 -0400

quickfix (1.13.3+dfsg-8) unstable; urgency=low

  * Standardize patch names and number patches
  * Fix FTBFS: explicitly use -pthread when building on kfreebsd-*

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 31 Mar 2014 10:02:48 -0400

quickfix (1.13.3+dfsg-7ubuntu1) trusty; urgency=medium

  * Use autotools-dev dh helper instead of manually copying config.{sub,guess}
    to fix FTBFS on arm64.

 -- Logan Rosen <logan@ubuntu.com>  Wed, 05 Mar 2014 14:19:00 -0500

quickfix (1.13.3+dfsg-7) unstable; urgency=low

  * Drop Ruby and Python bindings (Closes: #735438, #717412, #739779)
  * Update to Standards-Version 3.9.5 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 04 Mar 2014 08:44:50 -0500

quickfix (1.13.3+dfsg-6) unstable; urgency=low

  * Ensure `xargs` doesn't call `chmod` if nothing is found (Closes: #717199)
  * Document how to regenerate SWIG-generated files

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 20 Jul 2013 10:04:06 -0400

quickfix (1.13.3+dfsg-5) unstable; urgency=low

  * Add Vcs-* fields to debian/control
  * Update to Standards-Version 3.9.4 (no changes)
  * Build with hardening options, adjust flags, and fix binary-indep target
  * Patches to correct format string insecurity, as well replace deprecated
    calls (Closes: 676083)
  * Rename binary package libquickfix-ruby1.8 to ruby-quickfix, also remove
    binary support for Ruby 1.8 and add binary support for Ruby 1.9

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 10 Jul 2013 22:49:22 -0400

quickfix (1.13.3+dfsg-4) unstable; urgency=low

  * Change Build-Depends to use default Python version (Closes: #653798)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 03 Jan 2012 20:39:48 -0500

quickfix (1.13.3+dfsg-3) unstable; urgency=low

  * Apply test_runner_bad_virtual_method_arg.patch from unittest++ source,
    since quickfix embeds its own copy of UnitTest++ (Closes: #648257)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 26 Nov 2011 18:59:25 -0500

quickfix (1.13.3+dfsg-2) unstable; urgency=low

  * Only apply -msse3 optimization when it will work, thanks to Nobuhiro
    Iwamatsu for the patch (Closes: #644450)

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 10 Oct 2011 11:52:59 -0400

quickfix (1.13.3+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #642268)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 20 Sep 2011 18:09:58 -0400

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
 Standards-Version: 3.9.5
 Section: libs
 Homepage: http://www.quickfixengine.org/index.html
-Vcs-Browser: https://github.com/quickfix/quickfix
-Vcs-Git: git://github.com/quickfix/quickfix.git
+Vcs-Browser: https://quickfix.svn.sourceforge.net/svnroot/quickfix/trunk/quickfix
+Vcs-Svn: svn://svn.code.sf.net/p/quickfix/code/
 
 Package: libquickfix-dev
 Section: libdevel
 Architecture: any
-Depends: libquickfix14v5 (= ${binary:Version}), ${misc:Depends}
+Depends: libquickfix14 (= ${binary:Version}), ${misc:Depends}
 Suggests: libquickfix-doc
 Description: FIX protocol library - development files
  The Financial Information eXchange (FIX) Protocol is a message standard
@@ -23,11 +23,9 @@
  .
  This package includes the quickfix development files.
 
-Package: libquickfix14v5
+Package: libquickfix14
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libquickfix14
-Replaces: libquickfix14
 Description: FIX protocol library - runtime files
  The Financial Information eXchange (FIX) Protocol is a message standard
  developed to facilitate the electronic exchange of information related to
@@ -36,12 +34,10 @@
  .
  This package includes the quickfix runtime files.
 
-Package: libquickfix14v5-dbg
+Package: libquickfix14-dbg
 Section: debug
 Architecture: any
-Depends: libquickfix14v5 (= ${binary:Version}), ${misc:Depends}
-Conflicts: libquickfix14-dbg
-Replaces: libquickfix14-dbg
+Depends: libquickfix14 (= ${binary:Version}), ${misc:Depends}
 Description: FIX protocol library - debugging symbols
  The Financial Information eXchange (FIX) Protocol is a message standard
  developed to facilitate the electronic exchange of information related to

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/quilt/quilt.make

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH) 
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif


CC=/usr/bin/gcc
CXX=/usr/bin/g++
CFLAGS = -O3 -I/usr/include/mysql -I/usr/include/postgresql -I/usr/include/libxml2 -fPIC -DPIC
CXXFLAGS = -O3 -I/usr/include/mysql -I/usr/include/postgresql -I/usr/include/libxml2 -fPIC -DPIC

ifeq (amd64,$(DEB_HOST_ARCH)) 
CFLAGS += -O3 -msse3
CXXFLAGS += -O3 -msse3
endif

# Fix FTBFS on kfreebsd-* builds, which require explicit pthread linkage
# Using CFLAGS/CXXFLAGS feels like an ugly hack, but no amount of coaxing with
# DEB_LDFLAGS_MAINT_{PRE,AP}PEND seems to get the flag in the right position
ifneq (,$(findstring kfreebsd,$(DEB_HOST_ARCH)))
CFLAGS += -pthread
CXXFLAGS += -pthread
endif

#CFLAGS = -Wall -g

#ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
#	CFLAGS += -O0
#else
#	CFLAGS += -O2
#endif

dpkg_buildflags = DEB_CFLAGS_MAINT_APPEND="$(CFLAGS)" DEB_CXXFLAGS_MAINT_APPEND="$(CXXFLAGS)" DEB_LDFLAGS_MAINT_APPEND="-Wl,-z,defs" dpkg-buildflags

config.status: configure
configure: configure-stamp
configure-stamp: $(QUILT_STAMPFN)
	dh_testdir
	dh_autotools-dev_updateconfig
	# Add here commands to configure the package.
	libtoolize
	./configure $(CROSS) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CC="$(CC)" CXX="$(CXX)" --with-mysql=/usr --enable-new-allocator --with-postgresql=/usr --with-boost=/usr/include/boost $(shell $(dpkg_buildflags) --export=configure)
	touch configure-stamp


build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: config.status 
	dh_testdir
	[ -d $(CURDIR)/lib ] || mkdir $(CURDIR)/lib
	$(MAKE) $(shell $(dpkg_buildflags) --export=configure)
	touch $@

clean: unpatch
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	[ ! -f Makefile ] || $(MAKE) distclean
	-rmdir $(CURDIR)/lib
	dh_autotools-dev_restoreconfig
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
	$(MAKE) -C examples clean
	rm -f debian/tmp/usr/lib/*.la


# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i
	dh_installdocs -i -XChangeLog
	dh_installexamples -i
	dh_install -i --list-missing
	dh_installman -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	# dh_fixperms doesn't quite handle everything
	find $(CURDIR)/debian/libquickfix-doc/usr/share/doc/libquickfix-doc/examples -type f |xargs -r chmod 644
	dh_makeshlibs -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a -XChangeLog
	dh_installexamples -a
	dh_install -a --list-missing
	dh_installman -a
	dh_link -a
	dh_strip -a -Xexamples --dbg-package=libquickfix14-dbg
	dh_compress -a
	dh_fixperms -a
	# dh_fixperms doesn't quite handle everything
	find $(CURDIR)/debian/libquickfix-doc/usr/share/doc/libquickfix-doc/examples -type f |xargs -r chmod 644
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg[.\d]*//" \
http://sf.net/quickfix/quickfix-([.0-9]+)\.tar\.gz debian debian/repack.sh
# http://sf.net/quickfix/quickfix-([.0-9]+)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip) debian debian/repack.sh

## quickfix 1.14.4+dfsg

=== UnitTest++/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 CXX = g++
-CXXFLAGS ?= -g -Wall -W -Winline -ansi 
+CXXFLAGS ?= -g -Wall -W -Winline -Wno-unused-private-field -Wno-overloaded-virtual -ansi 
 LDFLAGS ?= 
 SED = sed
 MV = mv

=== debian/changelog ===
quickfix (1.14.4+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #831128)
  * Rename libquickfix14 -> libquickfix16
  * Dropped patches (incorporated upstream):
    + patches/01_uninitialized_v2.patch
    + patches/07_stdlib.patch
  * Dropped patches (obsolete):
    + patches/02_src_fieldbase_calculate.patch
    + patches/04_ruby_site_packages.patch
    + patches/05_ruby_hardcode_lower_optimization.patch
    + patches/06_build_system_cleanup.patch
    + patches/09_error_string_format.patch
    + patches/10_STR2CSTR_replace.patch
    + patches/11_RSTRING_update.patch
  * Refreshed patches:
    + patches/03_src_heartbeat.patch
    + patches/06_build_system_cleanup.patch
  * New patches:
    + patches/01_disable_problematic_tests.patch
    + patches/02_dtor_noexcept_false.patch
  * Update to debhelper compatibility level 9
  * Update obsolete build dependencies:
    + libmysqlclient-dev to default-libmysqlclient-dev (Closes: #845901)
    + libpqxx3-dev to libpqxx-dev (Closes: #814232)
  * Remove Vcs-* links pointing to upstream (Closes: #814231)
  * Update to Standards-Version 3.9.8 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 05 Dec 2016 00:04:14 -0500

quickfix (1.13.3+dfsg-9) unstable; urgency=low

  * Fix FTBFS on hurd-i386; thanks to Pino Toscano for the patch
    (Closes: #745943)
  * Fix incorrect manual copying of config.{sub,guess}; thanks to Logan
    Rosen for the patch (Closes: #745156)
  * Update Vcs-* fields to point to GitHub

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 19 Jun 2014 13:32:03 -0400

=== debian/control ===
Source: quickfix
Priority: extra
Maintainer: Athena Capital Research <acr-debian@athenacr.com>
Uploaders: Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: debhelper (>= 9),
 dh-autoreconf | debhelper (>= 9.20160403~),
 autotools-dev,
 autoconf,
 automake,
 doxygen,
 graphviz,
 quilt,
 libxml2-dev,
 default-libmysqlclient-dev,
 libpqxx-dev,
 libboost-all-dev,
 libtool,
 psmisc,
 flex,
 ruby
Standards-Version: 3.9.8
Section: libs
Homepage: http://www.quickfixengine.org/index.html

Package: libquickfix-dev
Section: libdevel
Architecture: any
Depends: libquickfix16 (= ${binary:Version}),
 ${misc:Depends}
Suggests: libquickfix-doc
Description: FIX protocol library - development files
 The Financial Information eXchange (FIX) Protocol is a message standard
 developed to facilitate the electronic exchange of information related to
 securities transactions. It is intended for use between trading partners
 wishing to automate communications.
 .
 This package includes the quickfix development files.

Package: libquickfix16
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: FIX protocol library - runtime files
 The Financial Information eXchange (FIX) Protocol is a message standard
 developed to facilitate the electronic exchange of information related to
 securities transactions. It is intended for use between trading partners
 wishing to automate communications.
 .
 This package includes the quickfix runtime files.

Package: libquickfix-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libquickfix-dev
Description: FIX protocol library - documentation
 The Financial Information Exchange (FIX) Protocol is a message standard
 developed to facilitate the electronic exchange of information related to
 securities transactions. It is intended for use between trading partners
 wishing to automate communications.
 .
 This package includes the quickfix documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1


# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	touch INSTALL ChangeLog
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --without-java --without-python --without-ruby
	# Restore empty lib/ directory used by upstream build system
	mkdir $(CURDIR)/lib

override_dh_auto_build:
	dh_auto_build
	(cd $(CURDIR)/doc ; ./document.sh)

override_dh_clean:
	dh_clean
	rm -rf INSTALL ChangeLog $(CURDIR)/lib

override_dh_fixperms:
	dh_fixperms
	find $(CURDIR)/debian \( -name Market.cpp -o -name '*.bat' \) -exec chmod 644 {} \;

## quickfix 1.15.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)

option(HAVE_EMX "Build with EMX")

if(HAVE_EMX)
message("-- Building with EMX")
add_definitions("-DHAVE_EMX=1")
set (quickfix_PROJECT_NAME quickfix-emx)
else()
set (quickfix_PROJECT_NAME quickfix)
endif()

project(${quickfix_PROJECT_NAME} VERSION 0.1 LANGUAGES CXX C)
message("-- Project name ${CMAKE_PROJECT_NAME}")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

include(QuickfixPlatformSettings)
include(QuickfixPrebuildSetup)

# Call cmake with-DHAVE_SSL=ON to compile with SSL. Similarly for others.
option(HAVE_SSL "Build with SSL")
option(HAVE_MYSQL "Build with MySQL")
option(HAVE_POSTGRESQL "Build with PostgreSQL")
option(HAVE_PYTHON "Build with default Python version")
option(HAVE_PYTHON2 "Build with default Python2 version")
option(HAVE_PYTHON3 "Build with default Python3 version")


#Make sure that a previous config.h has not undefined HAVE_SSL
if(HAVE_SSL)
# Can set location explicitly, example, cmake -DOPENSSL_ROOT_DIR=/usr/local/ssl -DOPENSSL_LIBRARIES=/usr/local/ssl/lib

find_package(OpenSSL REQUIRED)
include_directories(${OPENSSL_INCLUDE_DIR})

message("-- OPENSSL_INCLUDE_DIR: ${OPENSSL_INCLUDE_DIR}")
message("-- OPENSSL_LIBRARIES: ${OPENSSL_LIBRARIES}")
message("-- OPENSSL_ROOT_DIR: ${OPENSSL_ROOT_DIR}")

message("-- Building with SSL")
add_definitions("-DHAVE_SSL=1")
endif()

if(HAVE_MYSQL)
find_package(MySQL REQUIRED)
include_directories(${MYSQL_INCLUDE_DIR})

message("-- Building with MySQL")
add_definitions("-DHAVE_MYSQL=1")
endif()

if(HAVE_POSTGRESQL)
find_package(PostgreSQL REQUIRED)
include_directories(${PostgreSQL_INCLUDE_DIRS})

message("-- Building with POSTGRESQL")
add_definitions("-DHAVE_POSTGRESQL=1")
endif()

include(FindSharedPtr)
FIND_SHARED_PTR()
if (HAVE_SHARED_PTR_IN_STD_NAMESPACE)
message("-- set HAVE_STD_SHARED_PTR")
add_definitions("-DHAVE_STD_SHARED_PTR=1")
elseif(HAVE_SHARED_PTR_IN_TR1_NAMESPACE)
message("-- set HAVE_STD_TR1_SHARED_PTR")
add_definitions("-DHAVE_STD_TR1_SHARED_PTR=1")
elseif(HAVE_SHARED_PTR_IN_TR1_NAMESPACE_FROM_TR1_MEMORY_HEADER)
message("-- set HAVE_STD_TR1_SHARED_PTR_FROM_TR1_MEMORY_HEADER")
add_definitions("-DHAVE_STD_TR1_SHARED_PTR_FROM_TR1_MEMORY_HEADER=1")
else()
message("-- shared_ptr not found.")
endif()

include(FindUniquePtr)
FIND_UNIQUE_PTR()
if (HAVE_UNIQUE_PTR_IN_STD_NAMESPACE)
message("-- set HAVE_STD_UNIQUE_PTR")
add_definitions("-DHAVE_STD_UNIQUE_PTR=1")
endif()

if (HAVE_PYTHON)
find_package(PythonLibs REQUIRED)
include_directories(${PYTHON_INCLUDE_DIRS})
elseif (HAVE_PYTHON2)
find_package(PythonLibs 2 REQUIRED)
include_directories(${PYTHON_INCLUDE_DIRS})
elseif (HAVE_PYTHON3)
find_package(PythonLibs 3 REQUIRED)
include_directories(${PYTHON_INCLUDE_DIRS})
endif ()

if( WIN32 OR ${CMAKE_SYSTEM_NAME} STREQUAL "Linux" )
add_subdirectory(UnitTest++)
endif()

add_subdirectory(src)
add_subdirectory(examples)
if( WIN32)
add_subdirectory(test)
endif()

install(DIRECTORY ${CMAKE_SOURCE_DIR}/spec/ DESTINATION share/quickfix
  FILES_MATCHING PATTERN "FIX*.xml")

=== UnitTest++/CMakeLists.txt ===
set ( UnitTest++_SOURCES
src/AssertException.cpp
src/Checks.cpp
src/CurrentTest.cpp
src/DeferredTestReporter.cpp
src/DeferredTestResult.cpp
src/MemoryOutStream.cpp
src/ReportAssert.cpp
src/Test.cpp
src/TestDetails.cpp
src/TestList.cpp
src/TestReporter.cpp
src/TestReporterStdout.cpp
src/TestResults.cpp
src/TestRunner.cpp
src/TimeConstraint.cpp
src/XmlTestReporter.cpp
)

if (WIN32)
set (UnitTest++_SOURCES ${UnitTest++_SOURCES}
src/Win32/TimeHelpers.cpp)
else()
set (UnitTest++_SOURCES ${UnitTest++_SOURCES}
src/Posix/SignalTranslator.cpp
src/Posix/TimeHelpers.cpp)
endif()

add_library(UnitTest++ STATIC  ${UnitTest++_SOURCES})

set (TestUnitTest++_SOURCES
src/tests/Main.cpp
src/tests/TestAssertHandler.cpp
src/tests/TestCheckMacros.cpp
src/tests/TestChecks.cpp
src/tests/TestCurrentTest.cpp
src/tests/TestDeferredTestReporter.cpp
src/tests/TestMemoryOutStream.cpp
src/tests/TestTest.cpp
src/tests/TestTestList.cpp
src/tests/TestTestMacros.cpp
src/tests/TestTestResults.cpp
src/tests/TestTestRunner.cpp
src/tests/TestTestSuite.cpp
src/tests/TestTimeConstraint.cpp
src/tests/TestTimeConstraintMacro.cpp
src/tests/TestUnitTest++.cpp
src/tests/TestXmlTestReporter.cpp)

add_executable(TestUnitTest++ ${TestUnitTest++_SOURCES})

target_link_libraries(TestUnitTest++ UnitTest++)

=== UnitTest++/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 CXX = g++
-CXXFLAGS ?= -g -Wall -W -Winline -Wno-unused-private-field -Wno-overloaded-virtual -ansi 
+CXXFLAGS ?= -g -Wall -W -Winline -Wno-overloaded-virtual -Wno-unused-private-field -ansi 
 LDFLAGS ?= 
 SED = sed
 MV = mv

=== examples/CMakeLists.txt ===
add_subdirectory(executor)
add_subdirectory(tradeclient)
add_subdirectory(ordermatch)

=== src/CMakeLists.txt ===
add_subdirectory(C++)

if( WIN32 OR ${CMAKE_SYSTEM_NAME} STREQUAL "Linux" )

add_executable(at at.cpp getopt.c)

target_include_directories(at PRIVATE ${CMAKE_SOURCE_DIR} 
  ${CMAKE_SOURCE_DIR}/src/C++ ${CMAKE_SOURCE_DIR}/UnitTest++/src)
  
target_link_libraries(at ${PROJECT_NAME})

if (NOT WIN32)
ADD_CUSTOM_TARGET(at_target ALL
                  COMMAND ${CMAKE_COMMAND} -E create_symlink $<TARGET_FILE:at> ${CMAKE_SOURCE_DIR}/test/at)
else()
set_target_properties(at PROPERTIES
                      RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/test/debug/at/
                      RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/test/release/at/
                      RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${CMAKE_SOURCE_DIR}/test/release/at/)
endif()  


if (WIN32)
set (ut_SOURCES 
${CMAKE_SOURCE_DIR}/src/C++/test/DataDictionaryTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/DictionaryTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/FieldBaseTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/FieldConvertorsTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/FileLogTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/FileStoreFactoryTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/FileStoreTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/FileUtilitiesTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/GroupTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/HttpMessageTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/HttpParserTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/MemoryStoreTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/MessageSortersTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/MessagesTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/MySQLStoreTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/NullStoreTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/OdbcStoreTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/ParserTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/PostgreSQLStoreTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/SessionFactoryTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/SessionIDTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/SessionSettingsTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/SessionTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/SettingsTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/SocketAcceptorTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/SocketConnectorTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/SocketServerTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/StringUtilitiesTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/TestHelper.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/TimeRangeTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/UtcTimeOnlyTestCase.cpp
${CMAKE_SOURCE_DIR}/src/C++/test/UtcTimeStampTestCase.cpp)
endif()

add_executable(ut ut.cpp getopt.c ${ut_SOURCES})

target_include_directories(ut PRIVATE ${CMAKE_SOURCE_DIR} 
  ${CMAKE_SOURCE_DIR}/src/C++ ${CMAKE_SOURCE_DIR}/UnitTest++/src ${CMAKE_SOURCE_DIR}/src/C++/test/)
  
target_link_libraries(ut ${PROJECT_NAME} UnitTest++)

if (NOT WIN32)
ADD_CUSTOM_TARGET(ut_target ALL
                  COMMAND ${CMAKE_COMMAND} -E create_symlink $<TARGET_FILE:ut> ${CMAKE_SOURCE_DIR}/test/ut)
else()
set_target_properties(ut PROPERTIES
                      RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/test/debug/ut/
                      RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/test/release/ut/
                      RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${CMAKE_SOURCE_DIR}/test/release/ut/)
endif()  

add_executable(pt pt.cpp getopt.c)

target_include_directories(pt PRIVATE ${CMAKE_SOURCE_DIR} 
  ${CMAKE_SOURCE_DIR}/src/C++ ${CMAKE_SOURCE_DIR}/UnitTest++/src)
  
target_link_libraries(pt ${PROJECT_NAME})

if (NOT WIN32)
ADD_CUSTOM_TARGET(pt_target ALL
                  COMMAND ${CMAKE_COMMAND} -E create_symlink $<TARGET_FILE:pt> ${CMAKE_SOURCE_DIR}/test/pt)
else()
set_target_properties(pt PROPERTIES
                      RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/test/debug/pt/
                      RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/test/release/pt/
                      RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${CMAKE_SOURCE_DIR}/test/release/pt/)
endif()  

endif()

if (HAVE_PYTHON)
add_subdirectory(python)
elseif (HAVE_PYTHON2)
add_subdirectory(python2)
elseif (HAVE_PYTHON3)
add_subdirectory(python3)
endif ()

=== test/CMakeLists.txt ===
if (WIN32)
add_subdirectory(atrun)
endif()

=== examples/ordermatch/CMakeLists.txt ===
if (HAVE_SSL AND WIN32)
set(applink_SOURCE ${OPENSSL_INCLUDE_DIR}/openssl/applink.c)
endif()

add_executable(ordermatch Application.cpp Market.cpp ordermatch.cpp ${applink_SOURCE})

target_include_directories(ordermatch PRIVATE ${CMAKE_SOURCE_DIR}/include ${CMAKE_SOURCE_DIR}/include/quickfix ${CMAKE_SOURCE_DIR})


target_link_libraries(ordermatch ${PROJECT_NAME})

if (NOT WIN32)
ADD_CUSTOM_TARGET(ordermatch_target ALL
                  COMMAND ${CMAKE_COMMAND} -E create_symlink $<TARGET_FILE:ordermatch> ${CMAKE_SOURCE_DIR}/bin/ordermatch)
else()
set_target_properties(ordermatch PROPERTIES
                      RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/bin/debug/ordermatch/
                      RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/bin/release/ordermatch/
                      RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${CMAKE_SOURCE_DIR}/bin/release/ordermatch/)
endif()                   

if( WIN32 OR ${CMAKE_SYSTEM_NAME} STREQUAL "Linux" )
add_subdirectory(test)
endif()

=== examples/tradeclient/CMakeLists.txt ===
if (HAVE_SSL AND WIN32)
set(applink_SOURCE ${OPENSSL_INCLUDE_DIR}/openssl/applink.c)
endif()

add_executable(tradeclient Application.cpp tradeclient.cpp ${applink_SOURCE})

target_include_directories(tradeclient PRIVATE ${CMAKE_SOURCE_DIR}/include ${CMAKE_SOURCE_DIR}/include/quickfix ${CMAKE_SOURCE_DIR})


target_link_libraries(tradeclient ${PROJECT_NAME})

if (NOT WIN32)
ADD_CUSTOM_TARGET(tradeclient_target ALL
                  COMMAND ${CMAKE_COMMAND} -E create_symlink $<TARGET_FILE:tradeclient> ${CMAKE_SOURCE_DIR}/bin/tradeclient)
else()
set_target_properties(tradeclient PROPERTIES
                      RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/bin/debug/tradeclient/
                      RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/bin/release/tradeclient/
                      RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${CMAKE_SOURCE_DIR}/bin/release/tradeclient/)
endif()

=== src/C++/CMakeLists.txt ===
set(quickfix_VERSION_MAJOR 16)
set(quickfix_VERSION_MINOR 0)
set(quickfix_VERSION_PATCH 1)
set(quickfix_VERSION ${quickfix_VERSION_MAJOR}.${quickfix_VERSION_MINOR}.${quickfix_VERSION_PATCH} )

set(quickfix_SOURCES
  Acceptor.cpp
  DataDictionary.cpp
  DataDictionaryProvider.cpp
  Dictionary.cpp
  FieldConvertors.cpp
  FieldMap.cpp
  FieldTypes.cpp
  FileLog.cpp
  FileStore.cpp
  Group.cpp
  HttpConnection.cpp
  HttpMessage.cpp
  HttpParser.cpp
  HttpServer.cpp
  Initiator.cpp
  Log.cpp
  Message.cpp
  MessageSorters.cpp
  MessageStore.cpp
  MySQLLog.cpp
  MySQLStore.cpp
  NullStore.cpp
  OdbcLog.cpp
  OdbcStore.cpp
  Parser.cpp
  PostgreSQLLog.cpp
  PostgreSQLStore.cpp
  pugixml.cpp
  PUGIXML_DOMDocument.cpp
  Session.cpp
  SessionFactory.cpp
  SessionSettings.cpp
  Settings.cpp
  SocketAcceptor.cpp
  SocketConnection.cpp
  SocketConnector.cpp
  SocketInitiator.cpp
  SocketMonitor.cpp
  SocketServer.cpp
  stdafx.cpp
  ThreadedSocketAcceptor.cpp
  ThreadedSocketConnection.cpp
  ThreadedSocketInitiator.cpp
  TimeRange.cpp
  Utility.cpp
)

if (HAVE_SSL)
  set (quickfix_SOURCES ${quickfix_SOURCES}
    SSLSocketAcceptor.cpp
    SSLSocketConnection.cpp
    SSLSocketInitiator.cpp
    ThreadedSSLSocketAcceptor.cpp
    ThreadedSSLSocketConnection.cpp
    ThreadedSSLSocketInitiator.cpp
    UtilitySSL.cpp)
endif()

if (WIN32)
  add_library(${PROJECT_NAME} STATIC  ${quickfix_SOURCES})
  set_target_properties (${PROJECT_NAME} PROPERTIES DEBUG_POSTFIX d)
  target_link_libraries(${PROJECT_NAME} ${OPENSSL_LIBRARIES} ${MYSQL_CLIENT_LIBS} ${PostgreSQL_LIBRARIES} ws2_32)
else()
  add_library(${PROJECT_NAME} SHARED  ${quickfix_SOURCES})
  target_link_libraries(${PROJECT_NAME} ${OPENSSL_LIBRARIES} ${MYSQL_CLIENT_LIBS} ${PostgreSQL_LIBRARIES} pthread)
endif()

target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/C++)

set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${quickfix_VERSION} SOVERSION ${quickfix_VERSION_MAJOR} )

install(TARGETS ${PROJECT_NAME} DESTINATION lib)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/C++/ DESTINATION include/quickfix
        FILES_MATCHING PATTERN "*.h"
        PATTERN double-conversion EXCLUDE
        PATTERN test EXCLUDE)

=== src/python/CMakeLists.txt ===
set(quickfix_python_VERSION_MAJOR 16)
set(quickfix_python_VERSION_MINOR 0)
set(quickfix_python_VERSION_PATCH 1)
set(quickfix_python_VERSION ${quickfix_python_VERSION_MAJOR}.${quickfix_python_VERSION_MINOR}.${quickfix_python_VERSION_PATCH} )

set(quickfix_python_SOURCES QuickfixPython.cpp)
set(quickfix_python_lib_name _${PROJECT_NAME})

add_library(${quickfix_python_lib_name} SHARED  ${quickfix_python_SOURCES})

target_include_directories(${quickfix_python_lib_name} PRIVATE ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src/C++)

target_link_libraries(${quickfix_python_lib_name} ${PROJECT_NAME})

set_target_properties(${quickfix_python_lib_name} PROPERTIES VERSION ${quickfix_python_VERSION} SOVERSION ${quickfix_python_VERSION_MAJOR} PREFIX "")

install(TARGETS ${quickfix_python_lib_name} DESTINATION lib/python)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/python/ DESTINATION lib/python
        FILES_MATCHING PATTERN "quickfix*.py"
        PATTERN test EXCLUDE)

=== src/python2/CMakeLists.txt ===
set(quickfix_python_VERSION_MAJOR 16)
set(quickfix_python_VERSION_MINOR 0)
set(quickfix_python_VERSION_PATCH 1)
set(quickfix_python_VERSION ${quickfix_python_VERSION_MAJOR}.${quickfix_python_VERSION_MINOR}.${quickfix_python_VERSION_PATCH} )

set(quickfix_python_SOURCES QuickfixPython.cpp)
set(quickfix_python_lib_name _${PROJECT_NAME})

add_library(${quickfix_python_lib_name} SHARED  ${quickfix_python_SOURCES})

target_include_directories(${quickfix_python_lib_name} PRIVATE ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src/C++)

target_link_libraries(${quickfix_python_lib_name} ${PROJECT_NAME})

set_target_properties(${quickfix_python_lib_name} PROPERTIES VERSION ${quickfix_python_VERSION} SOVERSION ${quickfix_python_VERSION_MAJOR} PREFIX "")

install(TARGETS ${quickfix_python_lib_name} DESTINATION lib/python2)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/python/ DESTINATION lib/python2
        FILES_MATCHING PATTERN "quickfix*.py"
        PATTERN test EXCLUDE)

=== src/python3/CMakeLists.txt ===
set(quickfix_python_VERSION_MAJOR 16)
set(quickfix_python_VERSION_MINOR 0)
set(quickfix_python_VERSION_PATCH 1)
set(quickfix_python_VERSION ${quickfix_python_VERSION_MAJOR}.${quickfix_python_VERSION_MINOR}.${quickfix_python_VERSION_PATCH} )

set(quickfix_python_SOURCES QuickfixPython.cpp)
set(quickfix_python_lib_name _${PROJECT_NAME})

add_library(${quickfix_python_lib_name} SHARED  ${quickfix_python_SOURCES})

target_include_directories(${quickfix_python_lib_name} PRIVATE ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src/C++)

target_link_libraries(${quickfix_python_lib_name} ${PROJECT_NAME})

set_target_properties(${quickfix_python_lib_name} PROPERTIES VERSION ${quickfix_python_VERSION} SOVERSION ${quickfix_python_VERSION_MAJOR} PREFIX "")

install(TARGETS ${quickfix_python_lib_name} DESTINATION lib/python3)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/python/ DESTINATION lib/python3
        FILES_MATCHING PATTERN "quickfix*.py"
        PATTERN test EXCLUDE)

=== debian/changelog ===
quickfix (1.15.1+dfsg-4.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Also add support for riscv64 (Closes: #1012083)
    note: this riscv64+ loongarch64 patch should disappear on next release,
    because the stdc++ atomic will build just fine without embedded code
    copies patches
  * Update homepage field, the old website disappeared

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 14 Oct 2024 08:04:44 +0200

quickfix (1.15.1+dfsg-4.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ zhangdandan <zhangdandan@loongson.cn> ]
  * add support for loongarch64 (Closes: #1069887)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Sep 2024 15:45:21 +0200

quickfix (1.15.1+dfsg-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062767

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 22:38:19 +0000

quickfix (1.15.1+dfsg-4) unstable; urgency=medium

  * Use --with-openssl option when building (Closes: #959132)

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 29 Apr 2020 15:41:30 -0400

quickfix (1.15.1+dfsg-3) unstable; urgency=medium

  * Add appropriate multi-arch hints in debian/control
  * Update to Standards-Version 4.5.0 (no changes)
  * Don't let automake clobber user variables (e.g., INCLUDES, LDFLAGS,
    CXXFLAGS, etc.)
  * Update to debhelper compatibility level 10

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 23 Apr 2020 00:32:03 -0400

quickfix (1.15.1+dfsg-2) unstable; urgency=medium

  * Fix FTBFS on non-x86-based architectures by using Boost's atomic_count

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 28 Aug 2019 10:13:46 -0400

quickfix (1.15.1+dfsg-1) unstable; urgency=medium

  * New upstream release
    + Rebuild with current MariaDB libraries (Closes: #934818)
  * Rename libquickfix16 -> libquickfix17
  * libquickfix-dev: Add libxml2-dev as a dependency
  * Update to Standards-Version 4.4.0 (no changes)
  * Change package priority from 'extra' to 'optional'

 -- Roberto C. Sanchez <roberto@connexer.com>  Sun, 25 Aug 2019 07:23:31 -0400

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,8 @@
 Source: quickfix
-Priority: extra
+Priority: optional
 Maintainer: Athena Capital Research <acr-debian@athenacr.com>
 Uploaders: Roberto C. Sanchez <roberto@connexer.com>
-Build-Depends: debhelper (>= 9),
- dh-autoreconf | debhelper (>= 9.20160403~),
- autotools-dev,
- autoconf,
- automake,
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 10),
  doxygen,
  graphviz,
  quilt,
@@ -14,18 +10,22 @@
  default-libmysqlclient-dev,
  libpqxx-dev,
  libboost-all-dev,
+ libssl-dev,
  libtool,
  psmisc,
  flex,
  ruby
-Standards-Version: 3.9.8
+Standards-Version: 4.5.0
 Section: libs
-Homepage: http://www.quickfixengine.org/index.html
+Homepage: https://github.com/quickfix/quickfix
 
 Package: libquickfix-dev
 Section: libdevel
 Architecture: any
-Depends: libquickfix16 (= ${binary:Version}),
+Multi-Arch: same
+Depends: libquickfix17t64 (= ${binary:Version}),
+ libxml2-dev,
+ libssl-dev,
  ${misc:Depends}
 Suggests: libquickfix-doc
 Description: FIX protocol library - development files
@@ -36,8 +36,12 @@
  .
  This package includes the quickfix development files.
 
-Package: libquickfix16
+Package: libquickfix17t64
+Provides: ${t64:Provides}
+Replaces: libquickfix17
+Breaks: libquickfix17 (<< ${source:Version})
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends},
  ${misc:Depends}
 Description: FIX protocol library - runtime files
@@ -51,6 +55,7 @@
 Package: libquickfix-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Suggests: libquickfix-dev
 Description: FIX protocol library - documentation

=== debian/rules ===
--- 
+++ 
@@ -12,12 +12,17 @@
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
+export DEB_CXXFLAGS_MAINT_APPEND=-DENABLE_BOOST_ATOMIC_COUNT
+
 %:
+	dh $@
+
+override_dh_autoreconf:
 	touch INSTALL ChangeLog
-	dh $@ --with autoreconf
+	dh_autoreconf
 
 override_dh_auto_configure:
-	dh_auto_configure -- --without-java --without-python --without-ruby
+	dh_auto_configure -- --without-java --without-python --without-ruby --with-openssl
 	# Restore empty lib/ directory used by upstream build system
 	mkdir $(CURDIR)/lib

=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg[.\d]*//,filenamemangle=s/(?:[^\d\.]*)?v?\.?(\d[\d\.]*)\.tar\.gz/quickfix-$1.tar.gz/" \
    https://github.com/quickfix/quickfix/tags (?:[^\d\.]*)?v?\.?(\d[\d\.]*)\.tar\.gz \
    debian debian/repack.sh
